Overview | Package | Class | Tree | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.mac
Class UMac32

    java.lang.Object
      |
      +--gnu.crypto.mac.BaseMac
            |
            +--gnu.crypto.mac.UMac32

All Implemented Interfaces:
  java.lang.Cloneable, IMac

public class UMac32
extends BaseMac

The implementation of the UMAC (Universal Message Authentication Code).

The UMAC algorithms described are parameterized. This means that various low-level choices, like the endian convention and the underlying cryptographic primitive, have not been fixed. One must choose values for these parameters before the authentication tag generated by UMAC (for a given message, key, and nonce) becomes fully-defined. In this document we provide two collections of parameter settings, and have named the sets UMAC16 and UMAC32. The parameter sets have been chosen based on experimentation and provide good performance on a wide variety of processors. UMAC16 is designed to excel on processors which provide small-scale SIMD parallelism of the type found in Intel's MMX and Motorola's AltiVec instruction sets, while UMAC32 is designed to do well on processors with good 32- and 64- bit support. UMAC32 may take advantage of SIMD parallelism in future processors.

UMAC has been designed to allow implementations which accommodate on-line authentication. This means that pieces of the message may be presented to UMAC at different times (but in correct order) and an on-line implementation will be able to process the message correctly without the need to buffer more than a few dozen bytes of the message. For simplicity, the algorithms in this specification are presented as if the entire message being authenticated were available at once.

To authenticate a message, `Msg`, one first applies the universal hash function, resulting in a string which is typically much shorter than the original message. The pseudorandom function is applied to a nonce, and the result is used in the manner of a Vernam cipher: the authentication tag is the xor of the output from the hash function and the output from the pseudorandom function. Thus, an authentication tag is generated as

        AuthTag = f(Nonce) xor h(Msg)

Here `f` is the pseudorandom function shared between the sender and the receiver, and h is a universal hash function shared by the sender and the receiver. In UMAC, a shared key is used to key the pseudorandom function `f`, and then `f` is used for both tag generation and internally to generate all of the bits needed by the universal hash function.

The universal hash function that we use is called `UHASH`. It combines several software-optimized algorithms into a multi-layered structure. The algorithm is moderately complex. Some of this complexity comes from extensive speed optimizations.

For the pseudorandom function we use the block cipher of the Advanced Encryption Standard (AES).

The UMAC32 parameters, considered in this implementation are:

                                       UMAC32
                                       ------
            WORD-LEN                        4
            UMAC-OUTPUT-LEN                 8
            L1-KEY-LEN                   1024
            UMAC-KEY-LEN                   16
            ENDIAN-FAVORITE               BIG *
            L1-OPERATIONS-SIGN       UNSIGNED

Please note that this UMAC32 differs from the one described in the paper by the ENDIAN-FAVORITE value.

References:

1. UMAC: Message Authentication Code using Universal Hashing.
   T. Krovetz, J. Black, S. Halevi, A. Hevia, H. Krawczyk, and P. Rogaway.

Version:
  $Revision: 1.3 $

Field Summary
`(package private) static int` | `KEY_LEN`
`(package private) static int` | `L1_KEY_LEN`
`static java.lang.String` | `NONCE_MATERIAL` Property name of the user-supplied Nonce.
`(package private) static int` | `OUTPUT_LEN`

Fields inherited from class gnu.crypto.mac.BaseMac
`name, truncatedSize, underlyingHash`

Fields inherited from interface gnu.crypto.mac.IMac
`MAC_KEY_MATERIAL, TRUNCATED_SIZE`

Constructor Summary
`UMac32()` Trivial 0-arguments constructor.

Method Summary
`java.lang.Object` | `clone()` Returns a clone copy of this instance.
`byte[]` | `digest()` Completes the MAC by performing final operations such as padding and resetting the instance.
`void` | `init(java.util.Map attributes)` Initialising a UMAC instance consists of defining values for the following parameters:
`int` | `macSize()` Returns the output length in bytes of this MAC algorithm.
`void` | `reset()` Resets the algorithm instance for re-initialisation and use with other characteristics.
`boolean` | `selfTest()` A basic test.
`void` | `update(byte b)` Continues a MAC operation using the input byte.
`void` | `update(byte[] b, int offset, int len)` Continues a MAC operation, by filling the buffer, processing data in the algorithm's MAC_SIZE-bit block(s), updating the context and count, and buffering the remaining bytes in buffer for the next operation.

Methods inherited from class gnu.crypto.mac.BaseMac
`name`

Methods inherited from class java.lang.Object
`, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NONCE_MATERIAL

    public static final java.lang.String NONCE_MATERIAL

  Property name of the user-supplied Nonce. The value associated to this property name is taken to be a byte array.

### OUTPUT_LEN

    static final int OUTPUT_LEN

### L1_KEY_LEN

    static final int L1_KEY_LEN

### KEY_LEN

    static final int KEY_LEN

Constructor Detail

### UMac32

    public UMac32()

  Trivial 0-arguments constructor.

Method Detail

### clone

    public java.lang.Object clone()

  Description copied from interface: `IMac`

  Returns a clone copy of this instance.

  Overrides:
    `clone` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Returns:
    a clone copy of this instance.

### macSize

    public int macSize()

  Description copied from interface: `IMac`

  Returns the output length in bytes of this MAC algorithm.

  Overrides:
    `macSize` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Returns:
    the output length in bytes of this MAC algorithm.

### init

    public void init(java.util.Map attributes)
              throws java.security.InvalidKeyException,
                     java.lang.IllegalStateException

  Initialising a UMAC instance consists of defining values for the following parameters:

  1. Key Material: as the value of the attribute entry keyed by `IMac.MAC_KEY_MATERIAL`. The value is taken to be a byte array containing the user-specified key material. The length of this array, if/when defined SHOULD be exactly equal to `KEY_LEN`.
  2. Nonce Material: as the value of the attribute entry keyed by `NONCE_MATERIAL`. The value is taken to be a byte array containing the user-specified nonce material. The length of this array, if/when defined SHOULD be (a) greater than zero, and (b) less or equal to 16 (the size of the AES block).

  For convenience, this implementation accepts that not both parameters be always specified.

  - If the Key Material is specified, but the Nonce Material is not, then this implementation, re-uses the previously set Nonce Material after (a) converting the bytes to an unsigned integer, (b) incrementing the number by one, and (c) converting it back to 16 bytes.
  - If the Nonce Material is specified, but the Key Material is not, then this implementation re-uses the previously set Key Material.

  This method throws an exception if no Key Material is specified in the input map, and there is no previously set/defined Key Material (from an earlier invocation of this method). If a Key Material can be used, but no Nonce Material is defined or previously set/defined, then a default value of all-zeroes shall be used.

  Overrides:
    `init` in class `BaseMac`
  Parameters:
    `attributes` - one or both of required parameters.
  Throws:
    `java.security.InvalidKeyException` - the key material specified is not of the correct length.

### update

    public void update(byte b)

  Description copied from interface: `IMac`

  Continues a MAC operation using the input byte.

  Overrides:
    `update` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Parameters:
    `b` - the input byte to digest.

### update

    public void update(byte[] b,
                       int offset,
                       int len)

  Description copied from interface: `IMac`

  Continues a MAC operation, by filling the buffer, processing data in the algorithm's MAC_SIZE-bit block(s), updating the context and count, and buffering the remaining bytes in buffer for the next operation.

  Overrides:
    `update` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Parameters:
    `in` - the input block.
    `offset` - start of meaningful bytes in input block.
    `length` - number of bytes, in input block, to consider.

### digest

    public byte[] digest()

  Description copied from interface: `IMac`

  Completes the MAC by performing final operations such as padding and resetting the instance.

  Overrides:
    `digest` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Returns:
    the array of bytes representing the MAC value.

### reset

    public void reset()

  Description copied from interface: `IMac`

  Resets the algorithm instance for re-initialisation and use with other characteristics. This method always succeeds.

  Overrides:
    `reset` in class `BaseMac`

### selfTest

    public boolean selfTest()

  Description copied from interface: `IMac`

  A basic test. Ensures that the MAC of a pre-determined message is equal to a known pre-computed value.

  Overrides:
    `selfTest` in class `BaseMac`
  Following copied from interface: `gnu.crypto.mac.IMac`
  Returns:
    `true` if the implementation passes a basic self-test. Returns `false` otherwise.

Overview | Package | Class | Tree | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ©2001-2002 Free Software Foundation, Inc.. All Rights Reserved.